unit User;

interface

uses Windows, Graphics, SysUtils, Classes, Math;

const Extension = '.TXT';// L'extension doit tre reconnue par Windows (avec un excutable associ) pour pouvoir tre enregistre.

      Description = 'Fichier texte avec Shell'; // Pour renseigner le registre

      // Numro unique pour chaque Shell : Taper Ctrl+Shift+G dans l'diteur Delphi pour gnrer un TGUID
      Class_View: TGUID = '{625BA7AD-5BFF-4D5D-8FE4-CB6C3B4C33FA}';

// Renvoie le Bitmap de miniature du fichier FileName
procedure RecupererBitmap(FileName: string ; Bitmap: TBitmap);

// Renvoie la ligne d'information du fichier FileName (ligne affiche dans la barre d'tat notamment)
procedure RecupererInfo(FileName: string ; var Info: string);


implementation


procedure RecupererBitmap(FileName: string ; Bitmap: TBitmap);
const DeltaLigne=2;
var i: integer;
    F: TextFile;
    Chaine: string;
begin
     // Les dimensions du Bitmap par dfaut sont  rcuprer dans le Width et Height du Bitmap.
     // Mais on peut tout  fait modifier la taille : le changement d'chelle se fera automatiquement.

     Bitmap.Width:=96;
     Bitmap.Height:=96;
     try
        AssignFile(F, FileName);
        try
        Reset(F);
        i:=10;
        while (i<Bitmap.Height) and not Eof(F) do
        begin
             Readln(F, Chaine);
             Bitmap.Canvas.Textout(0,i,Chaine);
             i:=i+Bitmap.Canvas.TextHeight(Chaine)+DeltaLigne;
        end;
        finally
        CloseFile(F);
        end;
     except
         Chaine:=ExtractFileName(FileName);
         Bitmap.Canvas.Textout(0,(Bitmap.Height-Bitmap.Canvas.TextHeight(Chaine)) div 2,Chaine);
     end;
end;


procedure RecupererInfo(FileName: string ; var Info: string);
var SearchRec:TSearchRec;
    Resultat:integer;
begin
     try
     Resultat:=FindFirst(FileName, FaAnyFile, SearchRec);
     if Resultat=0 then Info:= 'Taille de ce fichier (en octets) : '+inttostr(SearchRec.Size)
                   else Info:='Erreur !';
     FindClose(SearchRec);
     except Info:='Erreur !'; end
end;

end.
